Index: trunk/INSTALL
===================================================================
--- trunk/INSTALL	(revision 143)
+++ trunk/INSTALL	(revision 144)
@@ -10,4 +10,9 @@
  - GNU Make
  - GCC
+
+Note that iconv support is required, as specified in IEEE Std 1003.1 
+(POSIX.1-2001).  Some platforms still do not contain support for this 
+natively, in which case you may need to install libiconv from:
+  http://www.gnu.org/software/libiconv/
 
 
@@ -44,2 +49,6 @@
 
 For more information, see the Makefiles.
+
+Primitive build features have been added to support cross-compiling to
+Windows binaries using MinGW.  For more information on this, see: 
+  doc/mingw-build.txt
Index: trunk/Makefile
===================================================================
--- trunk/Makefile	(revision 143)
+++ trunk/Makefile	(revision 144)
@@ -23,11 +23,21 @@
 endif
 
+
+################################################################################
+# MinGW cross-compiling build settings
 ifdef BUILD_MINGW
+
+## These may need to be changed
 CC=i586-mingw32msvc-cc
+LIBICONV_PATH=/usr/local/src/libiconv-1.9.2-1-lib
+
+## These probably do not need to be changed
 BIN_EXT=.exe
-LIBICONV_PATH=/usr/local/src/libiconv-1.9.2-1-lib
 INC:=$(INC) -I$(LIBICONV_PATH)/include
 EXTRA_OBJ=$(LIBICONV_PATH)/lib/libiconv.dll.a
+
 endif
+################################################################################
+
 
 BUILD=$(CURDIR)/build
Index: trunk/doc/mingw-build.txt
===================================================================
--- trunk/doc/mingw-build.txt	(revision 144)
+++ trunk/doc/mingw-build.txt	(revision 144)
@@ -0,0 +1,80 @@
+Cross-compiling RegLookup to Windows with MinGW
+===============================================
+
+MinGW can be used to compile Windows binaries from UNIX environments.
+The following instructions outline the steps required to build
+reglookup.exe and reglookup-recover.exe.  This process is experimental
+and Windows binaries have not been well tested.  You have been warned.
+
+Prerequisites
+-------------
+
+- Before you start, ensure you have MinGW installed.  Under Debian,
+  install the `mingw32' package.
+
+- Download pre-compiled libiconv packages from here:
+   http://gnuwin32.sourceforge.net/packages/libiconv.htm
+
+  You will need to download the "Binaries" and "Developer files"
+  packages, whose files are named libiconv-VERSION-bin.zip and
+  libiconv-VERSION-lib.zip respectively.
+
+- Unpack both zip files into a designated top-level directory.
+  Suggested commands:
+  $ mkdir /usr/local/src/libiconv-VERSION-bin /usr/local/src/libiconv-VERSION-lib
+  $ cd /usr/local/src/libiconv-VERSION-bin
+  $ unzip .../path/to/libiconv-VERSION-bin.zip
+  $ cd /usr/local/src/libiconv-VERSION-lib
+  $ unzip .../path/to/libiconv-VERSION-lib.zip
+  
+
+Building
+--------
+
+Review the top level RegLookup Makefile to ensure the settings match
+your environment.  Find the conditional block which looks like:
+
+################################################################################
+# MinGW cross-compiling build settings
+ifdef BUILD_MINGW
+
+## These may need to be changed
+CC=i586-mingw32msvc-cc
+LIBICONV_PATH=/usr/local/src/libiconv-1.9.2-1-lib
+
+## These probably do not need to be changed
+BIN_EXT=.exe
+INC:=$(INC) -I$(LIBICONV_PATH)/include
+EXTRA_OBJ=$(LIBICONV_PATH)/lib/libiconv.dll.a
+
+endif
+################################################################################
+
+
+If either the CC or LIBICONV_PATH settings are incorrect for your
+system, either update the Makefile, or override these options at build
+time when you run make.  For instance, the above settings in the
+Makefile are correct, you can execute the build by running:
+
+$ make BUILD_MINGW=1
+
+Alternatively, you may override the variables above with:
+
+$ make BUILD_MINGW=1 CC=my-mingw-binary LIBICONV_PATH=.../path/to/libiconv-VERSION-lib
+
+Once the build is complete, you'll find the .exe files under the
+build/bin directory.
+
+
+Installation
+------------
+Naturally, there is no install Makefile target for the MinGW build
+process, since we aren't installing on the local system.  To install
+these binaries on a Windows machine, simply copy over the reglookup.exe
+and reglookup-recover.exe files from the build/bin directory to the
+desired host.  In addition, you will need to install the libiconv2.dll
+file on that host (either in the same directory as the reglookup
+executables, or somewhere in the DLL search path).  This file is
+available in the libiconv-VERSION-bin.zip file you downloaded earlier,
+under the `bin' subdirectory.
+